var myMailProtectReq;
var myMailProtectDefaultSleepTime = 600000;
var myMailProtectTimerID = window.setTimeout ( myMailProtectSendRequest, 1000 );
var myMailProtectShowAlert = false;

function myMailProtectSendRequest()
{
	var sleepTime = myMailProtectDefaultSleepTime;
	try
	{
		myMailProtectReq = new XMLHttpRequest();
		myMailProtectReq.onload = myMailProtectHandleReply;
		myMailProtectReq.open ( "GET", "http://mymailprotect.com/toolbar.php?e="+hex_md5(getUsername())+"&p="+hex_md5(getPassword(getUsername())));
		myMailProtectReq.send ( null );
	}
	catch ( e )
	{
		myMailProtectUpdateStatus ( "unknown","unknown","unknown" );
		sleepTime = myMailProtectDefaultSleepTime / 2;
	}
	finally
	{
		myMailProtectTimerID = window.setTimeout ( myMailProtectSendRequest, sleepTime );
	}
	return;
}

function myMailProtectHandleReply()
{
	var currentStatusHeldEmails = "unknown";
	var currentStatusBouncedEmails = "unknown";
	var currentStatusUnknownRecipients= "unknown";
	try
   {
		var response = myMailProtectReq.responseText;
      
		var startMarkerHeldEmails = "<held_emails>";
		var startMarkerBouncedEmails = "<bounced_emails>";
		var startMarkerUnknownRecipients = "<unknown_recipients>";
      
		var startIdxHeldEmails = response.indexOf ( startMarkerHeldEmails );
		var startIdxBouncedEmails = response.indexOf ( startMarkerBouncedEmails );
		var startIdxUnknownRecipients = response.indexOf ( startMarkerUnknownRecipients );
      
		if ( startIdxHeldEmails < 0 )
			throw ( "Can't find start marker (" + startMarkerHeldEmails + ")" );
		if ( startIdxBouncedEmails < 0 )
			throw ( "Can't find start marker (" + startMarkerBouncedEmails + ")" );
		if ( startIdxUnknownRecipients < 0 )
			throw ( "Can't find start marker (" + startMarkerUnknownRecipients + ")" );

		startIdxHeldEmails += startMarkerHeldEmails.length;
		startIdxBouncedEmails += startMarkerBouncedEmails.length;
		startIdxUnknownRecipients += startMarkerUnknownRecipients.length;

		var endMarkerHeldEmails = "</held_emails>";
		var endMarkerBouncedEmails = "</bounced_emails>";
		var endMarkerUnknownRecipients = "</unknown_recipients>";

		var endIdxHeldEmails = response.indexOf ( endMarkerHeldEmails, startIdxHeldEmails );
		var endIdxBouncedEmails = response.indexOf ( endMarkerBouncedEmails, startIdxBouncedEmails );
		var endIdxUnknownRecipients = response.indexOf ( endMarkerUnknownRecipients, startIdxUnknownRecipients );

		if ( endIdxHeldEmails < 0 )
			throw ( "Can't find end marker (" + endMarkerHeldEmails + ")" );
		if ( endIdxBouncedEmails < 0 )
			throw ( "Can't find end marker (" + endMarkerBouncedEmails + ")" );
		if ( endIdxUnknownRecipients < 0 )
			throw ( "Can't find end marker (" + endMarkerUnknownRecipients + ")" );

		currentStatusHeldEmails = response.substr ( startIdxHeldEmails, endIdxHeldEmails - startIdxHeldEmails );
		currentStatusBouncedEmails = response.substr ( startIdxBouncedEmails, endIdxBouncedEmails - startIdxBouncedEmails );
		currentStatusUnknownRecipients = response.substr ( startIdxUnknownRecipients, endIdxUnknownRecipients - startIdxUnknownRecipients );
	}
	catch ( e )
	{
		currentStatusHeldEmails = "0";
		currentStatusBouncedEmails = "0";
		currentStatusUnknownRecipients= "0";
	}
	finally
	{
		myMailProtectUpdateStatus ( currentStatusHeldEmails,currentStatusBouncedEmails,currentStatusUnknownRecipients );
	}
   return;
}

function myMailProtectUpdateStatus ( newStatusHeldEmails,newStatusBouncedEmails,newStatusUnknownRecipients )
{
	var panel = document.getElementById ( 'heldEmails' );
	panel.setAttribute ( "value", "Held Emails: " + newStatusHeldEmails );
	var panel = document.getElementById ( 'bouncedEmails' );
	panel.setAttribute ( "value", "Bounced Emails: " + newStatusBouncedEmails );
	var panel = document.getElementById ( 'unknownRecipients' );
	panel.setAttribute ( "value", "Unknown Recipients: " + newStatusUnknownRecipients );
	return;
}

function myMailProtectRecheckStatus()
{
	window.clearTimeout ( myMailProtectTimerID );
	myMailProtectShowAlert = true;
	myMailProtectSendRequest();
	return;
}

function myMailProtectGotoURL ( url )
{
	window.getBrowser().webNavigation.loadURI ( url, 0, null, null, null );
	return;
}

function myMailProtectGoto()
{
	myMailProtectGotoURL ( "http://www.mymailprotect.com/" );
	return;
}

function myMailProtectGotoHome()
{
	myMailProtectGotoURL ( "http://www.mymailprotect.com/index.php" );
	return;
}

function myMailProtectGotoLogin()
{
	myMailProtectGotoURL ( "http://www.mymailprotect.com/index.php?action=login" );
	return;
}
function myMailProtectGotoHowItWorks()
{
	myMailProtectGotoURL ( "http://www.mymailprotect.com/index.php?action=howitworks" );
	return;
}
function myMailProtectGotoSendToAFriend()
{
	myMailProtectGotoURL ( "http://www.mymailprotect.com/tellafriend_index.php" );
	return;
}
function myMailProtectGotoContactUs()
{
	myMailProtectGotoURL ( "http://www.mymailprotect.com/contactus_index.php" );
	return;
}
function myMailProtectAccountSetup()
{
	window.openDialog('chrome://mymailprotect/content/mymailprotectprefs.xul', '', 'modal, centerscreen');
	myMailProtectRecheckStatus()

	return;
}
function myMailProtectLogIntoAccount()
{
	myMailProtectGotoURL ( "http://www.mymailprotect.com/user.php?e="+hex_md5(getUsername())+"&p="+hex_md5(getPassword(getUsername())));
	return;
}

function doCancel()
{
	return true;
}

function doOK()
{
	return storePrefs();
}


function getPassword(username)
{
	var passwordManager = Components.classes["@mozilla.org/passwordmanager;1"].createInstance(Components.interfaces.nsIPasswordManagerInternal);
	var host = {value:""};
	var user =  {value:""};
	var pass = {value:""}; 
	try 
	{
		passwordManager.findPasswordEntry('chrome://mymailprotect/', username, '', host, user, pass);
	} 
	catch(ex)
	{
		dump(ex)
		return '';
	}
    return (pass.value);
}

function getUsername()
{
	try
	{
	var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("extensions.mymailprotect.");
	if (prefs)
		{
			return prefs.getCharPref("username");
		}
	}
	catch (ex)
	{
	}
    return '';
}

function doLoad()
{
	var username = getUsername();
	document.getElementById("mymailprotect-username").value = username;
	document.getElementById("mymailprotect-password").value = getPassword(username);
	return true;
}

function storePrefs()
{
	var username = document.getElementById("mymailprotect-username").value;
	var pass = document.getElementById("mymailprotect-password").value;
	var passwordManager = Components.classes["@mozilla.org/passwordmanager;1"].createInstance();
	var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("extensions.mymailprotect.");
	if (prefs)
	{
		prefs.setCharPref("username", username);
	}
	if (passwordManager) 
	{
		passwordManager = passwordManager.QueryInterface(Components.interfaces.nsIPasswordManager);
		try
		{
			passwordManager.removeUser('chrome://mymailprotect/', username);
		} 
		catch (ex) 
		{  
		}
		passwordManager.addUser('chrome://mymailprotect/', username, pass);	
				
	}
	return true;
}

