// NOTE:
// this installation script is used only by Mozilla, not Firefox

// User defined constants
  const myProductName = "mymailprotect"; //same as the package name in contents.rdf
  const myProductRegKey = "/mozilla/mymailprotect";
  const myProductRegVersion = "1.0";
  const myJarFileName = "mymailprotect.jar";
  
// Installation Script
    
  var err = initInstall(myProductName, myProductRegKey, myProductRegVersion);
  logComment("initInstall: " + err);
  
  fChrome = getFolder("Chrome");
  setPackageFolder(fChrome);
    
  err = addFile("chrome/" + myJarFileName)             
  logComment("addFile() returned: " + err);
  
  regErr = registerChrome(PACKAGE | DELAYED_CHROME, getFolder(fChrome,myJarFileName), "content/mymailprotect/");
  logComment("regChrome returned: " + regErr);

  if (0 == getLastError())
    performInstall();
  else
    cancelInstall(err);
